// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

// Central data structure
// Array of [ webDomain -> (max length, user name) ]
var listeSites ;
var domainRegexp; 

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
	listeSites=new Object();
	// ^(.*://)?		=> pour http://
	// ([^/]*?.)?		=> pour le préfixe le plus court possible
	// ([^/.]*\.[^/.]*) => le nom de domaine
	// (/.*?)?$			=> la suite de l'url
	domainRegexp = new RegExp("^(.*://)?([^/]*?\\.)?([^/.]*\\.[^/.]*)(/.*?)?$");
	retrievePreferences();
	
    setupParts();
}

// Fonction qui renvoie le nom de domaine à partir d'une url
function domainFromSite(site)
{
	if ( ! site )  {
		return "";
	}
	// alert("domainFromSite : site = " + site);
	return site.replace(domainRegexp,"$3");
}


//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
	retrievePreferences();
}

//
// Function: save()
// save preferences (domain name)
//
function save() 
{
	widget.setPreferenceForKey(Object.toJSON(listeSites),"listeSites");
}

//
// Function: retrievePreferences()
// Load keys from preferences and update view
//
function retrievePreferences() 
{
	// alert(widget.preferenceForKey("listeSites"));
	var prefText=widget.preferenceForKey("listeSites")
	if (! prefText) {
		// alert("prefText vide");
		listeSites=new Object();
		return;
	}
	// alert("retrievePreferences : " + prefText);
	listeSites=prefText.evalJSON();
	if (! listeSites || ( listeSites.length == 0 ) ) {
		// alert("listeSites vide!");
		listeSites=new Object();
	}
	// in case of old recuperation repair the datastucture
	for (domain in listeSites) {
		if ( listeSites[domain]["kind"] !== undefined ) {
			listeSites[domain]["kind"]=1; 
		}
		else {
			break;
		}
	}
	updatePopup();
}


//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	
	calculeHash(event);
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

// ---------------- //

// Fonction qui calcule la valeur du hash
function calculeHash(event)
{
    // Insérer le code ici
	var password = document.getElementById("textfieldPassword").value ;
	var site = document.getElementById("textfieldSite").value;
	var hashTF = document.getElementById("textfieldHash");
	var maxlength = document.getElementById("sliderLength").value ;
	var kind = document.getElementById("kindPopup").object.getSelectedIndex();
	var id = document.getElementById("textfieldId").value;

	if ((password.length > 0 ) && (site.length > 0)) {
		// alert("calculeHash");
		var domain = domainFromSite( site );
		var hash = "";
		var suffix="";
		if (id > 0) {
			suffix=id;
		}
		switch ( kind ) {
		case 0: hash = b64_sha1(password+suffix+domain); break;
		case 1: hash = hex_sha1(password+suffix+domain); break;
		default: hash = "error in the switch! Contact the developper";
		}
		
		if (maxlength > hash.length) {
			document.getElementById("sliderLength").setValue( hash.length );
		}
		
		hashTF.value = hash.substr(0, maxlength );
	} else {
		hashTF.value = "";
	}
	hashTF.select();
	if (event) {
		if (event .clipboardData) {
			// alert("COPY");
			event.clipboardData.setData('text/plain',hashTF.value);
			event.preventDefault();
			event.stopPropagation();
		}
	}
}

// fonction appelée lors de la modification du slider
function sliderModified(event)
{
	// On met à jour le texte
	document.getElementById("textfieldMaxLength").value = document.getElementById("sliderLength").value ;
	updateState();
}

// Fonction a appeler quand on veut mettre à jour la structure
// de donnée (récupérer les actions de l'utilisateur)
function updateState(event) 
{
	calculeHash(event);
    // On sauvegarde si nécessaire
	var popupToChange   = document.getElementById("popupPourDomaine");
	var currentSite     = document.getElementById("textfieldSite").value;
	var currentUserName = document.getElementById("textfieldUserName").value;
	var currentLength   = document.getElementById("sliderLength").value;
	var currentKind		= document.getElementById("kindPopup").object.getSelectedIndex();
	var currentId		= document.getElementById("textfieldId").value;
	var currentDomain   = domainFromSite(currentSite);

	// synchronize la valeur dans le texte du slider avec la valeur enregistrée
	updateSlider(event);
	
	// Si le site est enregistré, on met à jour la popup
	// et on sauvegarde
	if (listeSites && listeSites[currentDomain]) {
		listeSites[currentDomain]["site"]		= currentSite;
		listeSites[currentDomain]["userName"]	= currentUserName;
		listeSites[currentDomain]["maxLength"]	= currentLength;
		listeSites[currentDomain]["kind"]		= currentKind;
		listeSites[currentDomain]["id"]			= currentId;
		updatePopup();
		save();
	}
}

// met à jour la popup
function updatePopup() {
	var popupToChange = document.getElementById("popupPourDomaine");
	var options = new Array();
	for (var domain in listeSites) {
		// alert("updatePopup : domain = " + domain );
		options.push(listeSites[domain]["site"]); 
	}
	options.sort();
	popupToChange.object.setOptions( options );

	// alert("updatePopup");
	var currentDomain = domainFromSite(document.getElementById("textfieldSite").value);
	options.map( domainFromSite );
	popupToChange.object.setSelectedIndex( options.indexOf(currentDomain) );
}

// fonction appelée lors de la modification du slider par un evênement interne
function updateSlider(event)
{
	// On met à jour le texte
	document.getElementById("textfieldMaxLength").value = document.getElementById("sliderLength").value ;
}

// fonction appelée lors d'une selection du menu déroulant
function popupDomaineChanged(event)
{
	if (! listeSites) 
	{
		return;
	}
		// alert("popupDomaineChanged");
 	var domainName = domainFromSite( document.getElementById("popupPourDomaine").object.getValue() );
	if (! domainName ) {
		return;
	}
	document.getElementById("textfieldSite").value		= listeSites[domainName]["site"] ;
	document.getElementById("textfieldUserName").value	= listeSites[domainName]["userName"] ;
	document.getElementById("sliderLength").value		= listeSites[domainName]["maxLength"] ;
	document.getElementById("kindPopup").object.setSelectedIndex(listeSites[domainName]["kind"]);
	if ( listeSites[domainName]["id"] ) {
		document.getElementById("textfieldId").value		= listeSites[domainName]["id"];
	} else {
		document.getElementById("textfieldId").value		= "0";	
	}
	updateSlider();
	calculeHash(null);
}

// Ajout un nouveau site dans la liste
function ajouteSite(event)
{
	// on ajoute le site dans la liste et on fait une mise à jour
	// à partir des champs actuels
	var currentSite = document.getElementById("textfieldSite").value;
	if (currentSite) {
		// alert("ajouteSite");
		var currentDomain = domainFromSite(currentSite);
		if (! listeSites[currentDomain]) {
			listeSites[currentDomain]=new Object();
		}
		updateState();
	}
}

// fonction qui supprime un site de la liste
function supprimeSite(event)
{
	var popupToChange = document.getElementById("popupPourDomaine");
	// alert("supprimeSite");
	var domainToDelete = domainFromSite(popupToChange.object.getValue());
	if (domainToDelete) {
		delete listeSites[domainToDelete];
	}
	updatePopup();
	save();
}

// fonction qui fait basculer en vue devant lorsque que l'on
// appuie sur entrée dans le champs password
function passwordValidated(event)
{
    if (event.keyCode == 13) {
		passwordEntered(event);
	}
}

// fonction qui met à jour l'affichage et affiche
// la vue de face (quand on clique sur le bouton 'Done'
// de la face configuration ou que l'on appuie sur entrer
function passwordEntered(event) {
	calculeHash();
	updateState(event);
	showFront(event);
}


function changePassword(event)
{
	var id = document.getElementById("textfieldId") ;
	id.value = parseInt(id.value) + 1;
	idChanged();
}


function resetPassword(event)
{
	var id = document.getElementById("textfieldId") ;
	id.value=0;
	idChanged();
}


function idChanged(event)
{
    updateState();
}


function goToWebsite(event)
{
    if (window.widget) {
		widget.openURL("http://yannesposito.com/YBlog/YPassword.html");
		return false;
	}
}
